//
//  HomeTableViewController.swift
//  PLOP-Demo
//
//  Created by Rainer Schaaf on 19.12.19.
//  Copyright © 2019 PDFlib GmbH. All rights reserved.
//

import UIKit

struct Example {
    var name: String
    var filename: String
    var classname: String
    var type: String
}

let examples = [
    Example(name: "dump PLOP-datasheet.pdf", filename: "PLOP-datasheet.pdf", classname: "dumper", type: "text"),
    Example(name: "encrypt PLOP-datasheet.pdf", filename: "PLOP-datasheet.pdf", classname: "plopencrypt", type: "pdf"),
    Example(name: "sign inoice.pdf", filename: "invoice.pdf", classname: "sign", type: "pdf")
]

class HomeTableViewController: UITableViewController, cellDelegate {

    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.tableView.tableFooterView = UIView()
        self.title = "PLOP Demo"
    }

    // MARK: - Table view data source
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return examples.count
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "cell", for: indexPath) as! TableViewCell

        cell.nameLabel.text = examples[indexPath.row].name
        cell.delegate = self
        return cell
    }
    
    //Mark: - custom cell delegate methods
    func didClickViewButton(cell: UITableViewCell) {
        let indexPath = self.tableView.indexPath(for: cell)
        if examples[indexPath!.row].type == "pdf" {
            let vc = self.storyboard?.instantiateViewController(withIdentifier: "PdfViewController") as! PdfViewController
            vc.filename = examples[indexPath!.row].filename
            vc.classname = examples[indexPath!.row].classname
            self.navigationController?.pushViewController(vc, animated: true)
        } else {
            let vc = self.storyboard?.instantiateViewController(withIdentifier: "TextViewController") as! TextViewController
            vc.fileName = examples[indexPath!.row].filename
            vc.className = examples[indexPath!.row].classname
            self.navigationController?.pushViewController(vc, animated: true)
        }
    }
}
