//
//  encryptViewController.m
//  PLOP examples
//
//  Created by Rainer Schaaf on 09.01.15.
//  Copyright (c) 2015 Rainer Schaaf. All rights reserved.
//

#import "encrypt.h"
#import "PLOP_ios/PLOP_objc.h"

@implementation plopencrypt

+ (NSData *) createPdf:(NSString *) fileName error:(NSError**)error {
    NSData *pdfData=nil;
    
    NSString *in_password = @"";
    NSString *out_master  = @"DEMO";
    NSString *out_user    = @"demo";
    NSString *permissions = @"";
    
    // This is where input files live. Adjust as necessary.
    NSString *searchpath = [[NSBundle mainBundle] resourcePath];
    
    PLOP *plop = [[PLOP alloc] init];
    if (!plop) {
        *error = [[NSError alloc] initWithDomain:@"PLOP out of memory error." code:[plop get_errnum] userInfo:nil];
        return nil;
    }

    @try {
        NSInteger doc;
        NSString *optlist;
        
        [plop set_option:[NSString stringWithFormat:@"searchpath {%@} ", searchpath]];
        
        // open unprotected input file without any password
        optlist = [NSString stringWithFormat:@"password {%@}", in_password];
        if ((doc = [plop open_document:fileName optlist:optlist]) == -1) {
            *error = [[NSError alloc] initWithDomain:[NSString stringWithFormat:@"Error: %@: %@", [plop get_apiname], [plop get_errmsg]] code:[plop get_errnum] userInfo:nil];
            return nil;
        }
        
        // create the output file with a password
        optlist = [NSString stringWithFormat:@"masterpassword={%@} userpassword={%@} "
                   "permissions={%@} input=%ld", out_master, out_user, permissions, (long)doc];
        if (([plop create_document:@"" optlist:optlist]) == -1) {
            *error = [[NSError alloc] initWithDomain:[NSString stringWithFormat:@"Error: %@: %@", [plop get_apiname], [plop get_errmsg]] code:[plop get_errnum] userInfo:nil];
            return nil;
        }
        pdfData = [plop get_buffer];
        
        // close input and output files
        [plop close_document:doc optlist:@""];
    }
    @catch (PLOPException *ex) {
        NSString *errorText = [NSString stringWithFormat:@"Error %ld in %@(): %@\n", (long)[ex get_errnum], [ex get_apiname], [ex get_errmsg]];
        *error = [[NSError alloc] initWithDomain:errorText code:[ex get_errnum] userInfo:nil];
        return nil;
    }
    
    return pdfData;
}

@end
