//
//  PdfViewController.swift
//  PLOP-Demo
//
//  Created by Rainer Schaaf on 20.12.19.
//  Copyright © 2019 PDFlib GmbH. All rights reserved.
//

import UIKit
import PDFKit

class PdfViewController: UIViewController {

    @IBOutlet weak var pdfView: PDFView!
    var classname:String! = ""
    var filename:String! = ""

    override func viewDidLoad() {
        super.viewDidLoad()
        
        do {
            let example: AnyClass? = NSClassFromString(classname)
            if let content = try example?.createPdf(filename)
            {
                self.title = filename
                pdfView.autoScales = true
                let pdfDocument = PDFDocument(data: content)
                pdfView.document = pdfDocument
            }
        } catch let error as NSError {
            let alert = UIAlertController(title: "PLOP exception", message:error.localizedDescription, preferredStyle: .alert)
            alert.addAction(UIAlertAction(title: "OK", style: .default) { _ in })
            self.present(alert, animated: true){}
        }
    }
}
